summaryrefslogtreecommitdiff
path: root/t/self-check-exit.tap
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-06-24 10:36:15 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-06-25 10:29:43 +0200
commitc2a52bf0e8e87b8f347ca22b9ab2da7613bc4336 (patch)
tree1e2115c0d24da906daa64cc84d853e538129574f /t/self-check-exit.tap
parentaa630a928a586fd8dc8a087337c3462d7f4fd1c6 (diff)
downloadautomake-c2a52bf0e8e87b8f347ca22b9ab2da7613bc4336.tar.gz
tests: simpler workaround for shells losing the exit status in exit trap
Now that we can assume our tests are run by a decent POSIX shell, we can simplify our workaround aimed at having the exit status propagated correctly to the code in the exit trap. Unfortunately, we cannot dispense with such a workaround altogether, because it's still required by some shells we need to support (at least Solaris 10 /bin/ksh and /usr/xpg4/bin/sh). For more information about the need of that workaround, see the entry about 'trap' in the section "Limitations of Shell Builtins" in the Autoconf manual: <http://www.gnu.org/software/autoconf/manual/autoconf.html#trap> The new workaround has been tested successfully with the following shells: - Bash 4.1 - Bash 3.2 - Bash 3.0 - Bash 2.05b - dash 0.5.5.1 - dash 0.5.2 - AT&T Ksh 93u (from official Debian package) - MirBSD Korn Shell 40.2 (from official Debian package) - Solaris 9, 10 and 11 /bin/ksh - Solaris 9, 10 and 11 /usr/xpg4/bin/sh - NetBSD 5.1 /bin/sh - NetBSD 5.1 /bin/ksh * t/ax/test-init.sh (Exit): Rename ... (_am_exit): ... like this. (exit): New alias for '_am_exit'. We cannot simply redefine 'exit' as a shell function, because some shells (dash 0.5.5.1, Solaris 10 /bin/ksh and /usr/xpg4/bin/sh) do not allow it. (_am_exit, trap): Add extra escaping for 'exit' calls, to ensure we really invoke the 'exit' builtin and not our alias with the same name. * configure.ac: Check that the shell selected to run our testsuite supports aliases named like shell builtins. * t/REAMDE: Adjust. * All tests: Adjust, by simply using 'exit' instead of 'Exit'. * t/self-check-explicit-skips.sh: Adjust: the first usage of 'exit' after it has been redefined as an alias must be on a new line w.r.t. that where the alias is defined, in order for the redefinition to be honored. * syntax-checks.mk (sc_tests_Exit_not_exit): Delete. (sc_tests_exit_not_Exit): New. (syntax_check_rules): Adjust. (sc_tests_automake_fails): Simplify the recipe a little. * Several tests: Remove now useless spurious quoting once required to placate the 'sc_tests_Exit_not_exit' maintainer check. * gen-testsuite-part: Likewise. Also, avoid uses of 'Exit' in the generated scripts. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/self-check-exit.tap')
-rwxr-xr-xt/self-check-exit.tap20
1 files changed, 11 insertions, 9 deletions
diff --git a/t/self-check-exit.tap b/t/self-check-exit.tap
index 0ad5651a1..e78ca0b2f 100755
--- a/t/self-check-exit.tap
+++ b/t/self-check-exit.tap
@@ -20,7 +20,7 @@
# Also check that the 'errexit' shell flag is active.
am_create_testdir=no
-. ./defs || Exit 99
+. ./defs || exit 99
plan_ 34
@@ -35,15 +35,17 @@ AM_TESTS_REEXEC=no; export AM_TESTS_REEXEC
# ./defs, i.e., when 'set -e' is not active yet, for the benefit of shells
# (like Bash 2.05 and Solaris 10 /bin/ksh) that returns a non-zero status
# when unsetting an already-unset variable.
-init='stderr_fileno_=2; unset am_explicit_skips; . ./defs'
+# Add an extra newline at the end so that the aliases defined by 'defs'
+# can take effect. Yes, this is truly required.
+init="stderr_fileno_=2; unset am_explicit_skips; . ./defs${nl}"
# Required so that the code in defs doesn't go crazy trying to creating a
# temporary directory in the absolute dir of $AM_TEST_RUNNER_SHELL.
dummy_test_script=t/$me.sh
for st in 1 2 3 4 5 77 99 126 127 128 129 130 255; do
- for exit_cmd in "Exit $st" "sh -c 'exit $st'"; do
- $AM_TEST_RUNNER_SHELL -c "$init; $exit_cmd; :" "$dummy_test_script"
+ for exit_cmd in "exit $st" "sh -c 'exit $st'"; do
+ $AM_TEST_RUNNER_SHELL -c "$init $exit_cmd; :" "$dummy_test_script"
command_ok_ "$exit_cmd" test $? -eq $st
done
done
@@ -59,7 +61,7 @@ for sig in 1 2 13 15; do
# <http://lists.gnu.org/archive/html/bug-autoconf/2011-09/msg00004.html>
trap : 2
fi
- $AM_TEST_RUNNER_SHELL -c "$init; kill -$sig \$\$; :" "$dummy_test_script"
+ $AM_TEST_RUNNER_SHELL -c "$init kill -$sig \$\$; :" "$dummy_test_script"
rc=$?
if test $sig -eq 2; then
# Reset default SIGINT handler as portably as possible.
@@ -84,20 +86,20 @@ if $AM_TEST_RUNNER_SHELL -c 'set -e; trap "exit \$?" 0; non-existent-program'; t
else
maybe_todo="" reason=""
fi
-$AM_TEST_RUNNER_SHELL -c "$init; non-existent-prog; :" "$dummy_test_script"
+$AM_TEST_RUNNER_SHELL -c "$init non-existent-prog; :" "$dummy_test_script"
command_ok_ "command not found" -D "$maybe_todo" -r "$reason" \
-- test $? -gt 0
: Non-executable command.
test -f Makefile && test ! -x Makefile || \
framowork_failure_ "no proper Makefile in the current directory"
-$AM_TEST_RUNNER_SHELL -c "$init; ./Makefile; :" "$dummy_test_script"
+$AM_TEST_RUNNER_SHELL -c "$init ./Makefile; :" "$dummy_test_script"
command_ok_ "permission denied" test $? -gt 0
: Syntax errors in the test code.
-$AM_TEST_RUNNER_SHELL -c "$init; if :; then" "$dummy_test_script"
+$AM_TEST_RUNNER_SHELL -c "$init if :; then" "$dummy_test_script"
command_ok_ "syntax error 1" test $? -gt 0
-$AM_TEST_RUNNER_SHELL -c "$init; true ( true )" "$dummy_test_script"
+$AM_TEST_RUNNER_SHELL -c "$init true ( true )" "$dummy_test_script"
command_ok_ "syntax error 2" test $? -gt 0
: